# -*- coding: utf-8 -*-

import logging

from tornado.tcpserver import TCPServer
from tornado.ioloop import IOLoop

from .share import CallBacksMixin
from .request import JSONRequest
from . import constants


class Kola(TCPServer, CallBacksMixin):
    """
    tcp server
    """

    terminator = None
    logger = None
    request_class = None

    def __init__(self, logger_name=None, request_class=None, **kwargs):
        TCPServer.__init__(self, **kwargs)
        CallBacksMixin.__init__(self)
        self.logger = logging.getLogger(logger_name or constants.LOGGER_NAME)
        self.request_class = request_class or JSONRequest

    def handle_stream(self, stream, address):
        self.request_class(self, stream, address)

    def run(self, host, port):
        self.listen(port, host)
        IOLoop.instance().start()